'=========================================================================
' Generic HTTP Downloader (v1.1)
'=========================================================================
'
' The this is a customised version of the Internet Script Template (v1.11)
' created by NeM used to download imformation from HTTP Pages.  The 
' original code can be found on the samurize forum.
'
' Used to retrive information from HTTP pages.  Through variables
'              
' 					                       - mnorth
'
' UPDATES
' 04 March 2004
' Now Supports etended character set
'
'=========================================================================
' VARIABLES :
'=========================================================================

' TMP_FILE: The name of the temp file you want to use for the script 
' 	(needed For the GetInfoTempFile() function only)
' SITE_URL: The url of the site you want to get your data from
' PAGE_CHECK: A string in the HTML source to verify that you have got the
' 	right page (eg. use the page title)
' FIRST_CHECK: String to mark the start of the entire text area to be
' 	examined
' END_CHECK: String marking the end of the entire section to be searched
' FIRST_CHECK2: String marking the start of the item(s) you wish to return
' END_CHECK2: String marking the end of the item(s) you wish to return
'
'=========================================================================


'=========================================================================
' Remove new line chrs between returned items
'=========================================================================
REMOVE_NEWLINES = False
'=========================================================================

' Returns the required items from the HTML string
Function GetInfo(SITE_URL, PAGE_CHECK, FIRST_CHECK, END_CHECK, FIRST_CHECK2, END_CHECK2)

	dim htmlResult,output,newsItem,mainFeature
	htmlResult = ReturnHTML(SITE_URL)
	output = NULL

	startPos = instr(htmlResult, PAGE_CHECK)

	If startPos > 0 Then
		
		'Selects on the string to search in
		startPos = instr(startPos, htmlResult, FIRST_CHECK) + len(FIRST_CHECK)
		endPos = instr(startPos, htmlResult, END_CHECK) - startPos
		htmlResult = mid(htmlResult, startPos, endPos)
		
		StartPos = 1
			Do While instr(startPos, htmlResult, FIRST_CHECK2)>0

			posOne = instr( startPos, htmlResult, FIRST_CHECK2)
			posTwo = instr( posOne, htmlResult, END_CHECK2)

			If posOne > 0 And posTwo > posOne Then

				'grab the name of the news item
				newsItem = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne)
				newsItem = trim(replace(newsitem, vbCrlf,""))
			End If

			' new start position
			startPos = posTwo

			'append the user to the list and put a newline char after it
			output = output & newsItem & vbCrlf

		Loop

	Else
		output = "Could not obtain data."
	End If

	GetInfo = TrimHTML(output)
	GetInfo = ReplaceHTML(GetInfo)

	If REMOVE_NEWLINES Then
		GetInfo = Replace(GetInfo, vbCr, " ")
		GetInfo = Replace(GetInfo, vbLf, " ")
		GetInfo = Replace(GetInfo, vbCrlf, " ")
	End If

	GetInfo = Trim(GetInfo)

End Function

' Puts the HTML string in TMP_FILE in samurize directory
Function GetInfoTempFile(TMP_FILE, SITE_URL, PAGE_CHECK, FIRST_CHECK, END_CHECK, FIRST_CHECK2, END_CHECK2)
	set fs=CreateObject("Scripting.FileSystemObject")
	Set f=fs.CreateTextFile(TMP_FILE & ".tmp",True)
	f.write(GetInfo(SITE_URL, PAGE_CHECK, FIRST_CHECK, END_CHECK, FIRST_CHECK2, END_CHECK2))
	f.close
	set f=nothing
	set fs=nothing

	GetInfoTempFile = "OK!"
End Function

' Gets the HTML string from the web page
Private Function ReturnHTML(sURL)
	Dim ADODBStream, objXMLHTTP
	Set ADODBStream = CreateObject("ADODB.Stream")
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")

	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	'Outputs Binary Stream
	ADODBStream.Type = 1
	ADODBStream.Open
	ADODBStream.Write objXMLHTTP.responsebody
	ADODBStream.SaveToFile "StrHTML.tmp", 2
	ADODBStream.Type = 1
	ADODBStream.Close
	'INPUTS TEXT STREAM
	ADODBStream.Type = 2
	ADODBStream.Charset = "utf-7"
	ADODBStream.Open
	ADODBStream.LoadFromFile "StrHTML.tmp"
	ReadTextFile = ADODBStream.ReadText
	ADODBStream.Close
	ReturnHTML = ReadTextFile

	Set objXMLHTTP = Nothing
	Set ADODBStream = Nothing
End Function

'very simple function that will remove all html tags
'(posted by Alderaic)
'---------------------------------------------------
Private Function TrimHTML(str)
pos_deb = InStr(1, str, "<")
Do Until pos_deb = 0
    pos_fin = InStr(pos_deb, str, ">")
    part_d = Mid(str, 1, pos_deb - 1)
    part_f = Mid(str, pos_fin + 1, Len(str) - pos_fin)
    str = part_d & part_f
    pos_deb = InStr(1, str, "<")
Loop
TrimHTML = str
End Function


'ReplaceHTML (posted by Goodspeed)
'---------------------------------
Private Function ReplaceHTML(str)

 str = replace(str, "&nbsp;", " ")
 str = replace(str, "&auml;", "")
 str = replace(str, "&uuml;", "")
 str = replace(str, "&ouml;", "")
 str = replace(str, "&Auml;", "")
 str = replace(str, "&Uuml;", "")
 str = replace(str, "&Ouml;", "")
 str = replace(str, "&szlig;", "")
 str = replace(str, "&quot;", """")
 str = replace(str, "&euro;", "")
 str = replace(str, "&pound;", "")
 str = replace(str, "&yen;", "")
 str = replace(str, "&amp;", "&")
 str = replace(str, "&lt;", "<")
 str = replace(str, "&gt;", ">")
 str = replace(str, "&iexcl;", "")
 str = replace(str, "&cent;", "")
 str = replace(str, "&curren;", "")
 str = replace(str, "&brvbar;", "")
 str = replace(str, "&sect;", "")
 str = replace(str, "&uml;", "")
 str = replace(str, "&copy;", "")
 str = replace(str, "&ordf;", "")
 str = replace(str, "&laquo;", "")
 str = replace(str, "&not;", "")
 str = replace(str, "&shy;", "")
 str = replace(str, "&reg;", "")
 str = replace(str, "&macr;", "")
 str = replace(str, "&deg;", "")
 str = replace(str, "&plusmn;", "")
 str = replace(str, "&sup2;", "")
 str = replace(str, "&sup3;", "")
 str = replace(str, "&acute;", "")
 str = replace(str, "&micro;", "")
 str = replace(str, "&para;", "")
 str = replace(str, "&middot;", "")
 str = replace(str, "&cedil;", "")
 str = replace(str, "&sup1;", "")
 str = replace(str, "&ordm;", "")
 str = replace(str, "&raquo;", "")
 str = replace(str, "&frac14;", "")
 str = replace(str, "&frac12;", "")
 str = replace(str, "&frac34;", "")
 str = replace(str, "&iquest;", "")
 str = replace(str, "&Agrave;", "")
 str = replace(str, "&Aacute;", "")
 str = replace(str, "&Acirc;", "")
 str = replace(str, "&Atilde;", "")
 str = replace(str, "&Aring;", "")
 str = replace(str, "&AElig;", "")
 str = replace(str, "&Ccedil;", "")
 str = replace(str, "&Egrave;", "")
 str = replace(str, "&Eacute;", "")
 str = replace(str, "&Ecirc;", "")
 str = replace(str, "&Euml;", "")
 str = replace(str, "&Igrave;", "")
 str = replace(str, "&Iacute;", "")
 str = replace(str, "&Icirc;", "")
 str = replace(str, "&Iuml;", "")
 str = replace(str, "&ETH;", "")
 str = replace(str, "&Ntilde;", "")
 str = replace(str, "&Ograve;", "")
 str = replace(str, "&Oacute;", "")
 str = replace(str, "&Ocirc;", "")
 str = replace(str, "&Otilde;", "")
 str = replace(str, "&times;", "")
 str = replace(str, "&Oslash;", "")
 str = replace(str, "&Ugrave;", "")
 str = replace(str, "&Uacute;", "")
 str = replace(str, "&Ucirc;", "")
 str = replace(str, "&Yacute;", "")
 str = replace(str, "&THORN;", "")
 str = replace(str, "&agrave;", "")
 str = replace(str, "&aacute;", "")
 str = replace(str, "&acirc;", "")
 str = replace(str, "&atilde;", "")
 str = replace(str, "&aring;", "")
 str = replace(str, "&aelig;", "")
 str = replace(str, "&ccedil;", "")
 str = replace(str, "&egrave;", "")
 str = replace(str, "&eacute;", "")
 str = replace(str, "&ecirc;", "")
 str = replace(str, "&euml;", "")
 str = replace(str, "&igrave;", "")
 str = replace(str, "&iacute;", "")
 str = replace(str, "&icirc;", "")
 str = replace(str, "&iuml;", "")
 str = replace(str, "&eth;", "")
 str = replace(str, "&ntilde;", "")
 str = replace(str, "&ograve;", "")
 str = replace(str, "&oacute;", "")
 str = replace(str, "&ocirc;", "")
 str = replace(str, "&divide;", "")
 str = replace(str, "&oslash;", "")
 str = replace(str, "&ugrave;", "")
 str = replace(str, "&uacute;", "")
 str = replace(str, "&ucirc;", "")
 str = replace(str, "&yacute;", "")
 str = replace(str, "&thorn;", "")
 str = replace(str, "&yuml;", "")
 str = replace(str, "&#8217;", "'")
 
 ReplaceHTML = Str
 
End Function